/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://kenai.com/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.observation.simple;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.spi.FinderSupport;
import it.tidalwave.observation.Finder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class SimpleFinderSupport<T extends As> extends FinderSupport<T, Finder<T>> implements Finder<T>
  {
    private final static long serialVersionUID = 12315656347568673L;
    
    @Nonnull
    private List<T> contents = new ArrayList<T>();

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public SimpleFinderSupport (final @Nonnull Collection<T> contents)
      {
        super("xxx");
        this.contents.addAll(contents);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public SimpleFinderSupport<T> clone()
      {
        final SimpleFinderSupport<T> clone = (SimpleFinderSupport<T>)super.clone();
        clone.contents = new ArrayList<T>(this.contents);
        
        return clone;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override @Nonnull
    protected List<T> computeResults()
      {
        return contents;
      }
  }
